/*****************************************************************************

				WWIV Version 4
		      Copyright (C) 1988 by Wayne Bell

Distribution of the source code for WWIV, in any form, modified or unmodified,
without PRIOR, WRITTEN APPROVAL by the author, is expressly prohibited.
Distribution of compiled versions of WWIV is limited to copies compiled BY
THE AUTHOR.  Distribution of any copies of WWIV not compiled by the author
is expressly prohibited.


*****************************************************************************/



#include <stdio.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <io.h>
#include <alloc.h>
#include <stdlib.h>
#include "vardec.h"
#include "fcns.h"

extern userrec thisuser;
extern directoryrec directories[64];
extern int num_dirs,hangup,userfile,echo,useron,userfile,usernum;
extern int incom,fwaiting,helpl;
extern configrec syscfg;
extern statusrec status;
extern char ctypes[NUM_CTYPES][18];
extern int edlf,dlf,curdir,numf;
extern usersubrec udir[64];
extern long nscandate;
extern char curspeed[81],cdir[81],dszlog[81];
extern unsigned int modem_speed,com_speed;
extern float batchtime;
extern int numbatch, numbatchdl, num_listed;
extern batchrec *batch;
extern double extratimecall;
extern unsigned char realsl;

#define SETREC(i)  lseek(dlf,((long) (i))*((long)sizeof(uploadsrec)),SEEK_SET);


void listbatch()
{
  char s[81];
  int abort,i;

  abort=0;
  nl();
  sprintf(s,"Files - %d  Time - %s",numbatch,ctim(batchtime));
  pl(s);
  nl();
  for (i=0; (i<numbatch) && (!abort) && (!hangup); i++) {
    sprintf(s,"%d. (%s) %s   %s",i+1,batch[i].sending?"D":"U",
      batch[i].filename,ctim(batch[i].time));
    pla(s,&abort);
  }
}

void delbatch(int i)
{
  int i1;

  if (i<numbatch) {
    batchtime -= batch[i].time;
    if (batch[i].sending)
      --numbatchdl;
    --numbatch;
    for (i1=i; i1<=numbatch; i1++) {
      batch[i1]=batch[i1+1];
    }
  }
}

void downloaded(char *fn)
{
  int i,i1;
  uploadsrec u;
  char s[81];

  for (i1=0; i1<numbatch; i1++) {
    if ((strcmp(fn,batch[i1].filename)==0) && (batch[i1].sending)) {
      dliscan1(batch[i1].dir);
      i=recno((batch[i1].filename));
      if (i>0) {
        SETREC(i);
        read(dlf,(void *)&u,sizeof(uploadsrec));
        ++thisuser.downloaded;
        thisuser.dk += (int) ((u.numbytes+1023)/1024);
        ++u.numdloads;
        SETREC(i);
        write(dlf,(void *)&u,sizeof(uploadsrec));
        sprintf(s,"Downloaded '%s'",u.filename);
        sysoplog(s);
        sprintf(s,"%s downloaded '%s' on %s",
          nam(&thisuser,usernum), u.filename, date());
        ssm(u.ownerusr,0,s);
      }
      closedl();
      delbatch(i1);

      return;
    }
  }
  sprintf(s,"!!! Couldn't find '%s' in DL batch queue.",fn);
  sysoplog(s);
}


void uploaded(char *fn)
{
  int i,i1;
  uploadsrec u;
  char s[81];

  for (i1=0; i1<numbatch; i1++) {
    if ((strcmp(fn,batch[i1].filename)==0) && (!batch[i1].sending)) {
      dliscan1(batch[i1].dir);
      i=recno((batch[i1].filename));
      if (i>0) {
        SETREC(i);
        read(dlf,(void *)&u,sizeof(uploadsrec));

        /* more here */

        ++thisuser.uploaded;
        thisuser.uk += (int) ((u.numbytes+1023)/1024);
        ++status.uptoday;
        save_status();
        SETREC(i);
        write(dlf,(void *)&u,sizeof(uploadsrec));
        sprintf(s,"+%s uploaded on %s",
          u.filename,
          directories[batch[i1].dir].name);
        sysoplog(s);
      }
      closedl();
      delbatch(i1);

      return;
    }
  }
  sprintf(s,"!!! Couldn't find '%s' in UL batch queue.",fn);
  sysoplog(s);
}

void ymbatchdl(int had)
{
  int rr,i,ok,cur=0;
  char s[81];
  uploadsrec u;
  double percent;

  if (!incom)
    return;
  sprintf(s,"YMBATCH, %d files, time=%s",numbatchdl, ctim(batchtime));
  if (had)
    strcat(s,", HAD");
  sysoplog(s);

  rr=0;
  do {
    tleft(1);
    if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
      rr=1;
    if (thisuser.exempt & exempt_ratio)
      rr=0;
    if (!batch[cur].sending) {
      rr=0;
      ++cur;
    }
    if ((nsl()>=batch[cur].time) && (!rr)) {
      dliscan1(batch[cur].dir);
      i=recno(batch[cur].filename);
      if (i<=0) {
        delbatch(cur);
        closedl();
      } else {
        sprintf(s,"%d files left, Time left = %s\r\n",numbatchdl,ctim(batchtime));
        outs(s);
        SETREC(i);
        read(dlf,(void *)&u,sizeof(uploadsrec));
        closedl();
        strcpy(s,directories[batch[cur].dir].path);
        strcat(s,u.filename);
        xymodem_send(s,&ok,&percent,u.filetype,1,1,1);
        if (ok) {
          downloaded(u.filename);
        } else {
          closedl();
        }
      }
    } else
      delbatch(cur);
  } while ((ok) && (!hangup) && (numbatch>cur) && (!rr));
  if ((ok) && (!hangup))
    endbatch();
  if (rr) {
    nl();
    pl("Your ratio is too low to continue the transfer.");
    nl();
  }
}


void handle_dszline(char *l)
{
  char *ss;
  int i;
  char s[161];

  /* find the filename */
  ss=strtok(l," \t");
  for (i=0; (i<10) && (ss); i++)
    ss=strtok(NULL," \t");

  if (ss) {
    strcpy(s,stripfn(ss));
    align(s);

    switch(*l) {
      case 'Z':
      case 'S':
      case 'R':
      case 'B':
        /* received a file */
        uploaded(s);
        break;

      case 'z':
      case 's':
      case 'r':
      case 'b':
        /* sent a file */
        downloaded(s);
        break;

      case 'E':
      case 'L':
      case 'U':
        /* error */
        sprintf(s,"Error transferring '%s'",ss);
        sysoplog(s);
        break;
    }
  }
}



double ratio1(long a)
{
  double r;

  if ((thisuser.dk==0) && (a==0))
    return(99.999);
  r=((float) thisuser.uk) / ((float) (thisuser.dk + a));
  if (r>99.998)
    r=99.998;
  return(r);
}

void process_dszlog()
{
  int f,i,i1;
  char *ss;
  char *lines[100];

  f=open(dszlog,O_RDONLY | O_TEXT);
  if (f>0) {
    i1=(int)filelength(f);
    ss=malloca(i1);
    if (ss) {
      i=read(f,ss,i1);
      if (i>0) {
        ss[i]=0;
        lines[0]=strtok(ss,"\n");
        for (i=1; (i<90) && (lines[i-1]); i++)
          lines[i]=strtok(NULL,"\n");

        lines[99]=NULL;

        for (i1=0; lines[i1]; i1++) {
          handle_dszline(lines[i1]);
        }

      }
      farfree(ss);
    }
    close(f);
  }
  _chmod(dszlog,1,0);
  unlink(dszlog);
}


void dszbatchdl(int had)
{
  char s[255],listfn[81],sx1[21],sx2[21],sx3[21],dl[100];
  int i,i1,f,ok;
  double at=0.0;
  long addk=0,thisk;


  sprintf(dl,"DSZBATCH, %d files, time=%s",numbatchdl, ctim(batchtime));
  if (had)
    strcat(dl,", HAD");
  sysoplog(dl);

  sprintf(listfn,"%s\\FILES.DL",cdir);

  _chmod(listfn,1,0);
  unlink(listfn);
  _chmod(dszlog,1,0);
  unlink(dszlog);

  f=open(listfn,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  if (f<0)
    return;

  for (i=0; i<numbatch; i++) {
    if (batch[i].sending) {
      sprintf(s,"%s%s\r\n",directories[batch[i].dir].path,stripfn(batch[i].filename));
      ok=1;
      if (nsl() < (batch[i].time + at))
        ok=0;
      thisk=(batch[i].len+1023)/1024;
      if ((syscfg.req_ratio>0.0001) && (ratio1(addk+thisk)<syscfg.req_ratio) &&
          (!(thisuser.exempt & exempt_ratio)))
        ok=0;
      if (ok) {
        write(f,s,strlen(s));
        at += batch[i].time;
        addk += thisk;
      }
    }
  }
  close(f);

  ultoa(com_speed,sx1,10);
  ultoa(modem_speed,sx3,10);
  sx2[0]='0'+syscfg.primaryport;
  sx2[1]=0;
  stuff_in(s,syscfg.dszbatchdl,sx1,sx2,listfn,sx3,"");
  if (s[0]) {
    clrscrb();
    outs(dl);
    outs("\r\n");
    outs(s);
    outs("\r\n");
    if (incom) {
      run_external1(s);
      process_dszlog();
      topscreen();
    }
  }

  _chmod(listfn,1,0);
  unlink(listfn);
  _chmod(dszlog,1,0);
  unlink(dszlog);
}

void batchdl()
{
  int i,abort,done,i1,i2,had,dsz;
  char s[81],ch,ch1;

  done=0;
  if (numbatch==0) {
    nl();
    pl("No files in queue.");
    nl();
    return;
  }
  do {
    nl();
    prt(2,"Batch: L,D,R,Q,C,? : ");
    ch=onek("Q?CLRD");
    switch(ch) {
      case '?':
        printmenu(9);
        break;
      case 'Q':
        done=1;
        break;
      case 'L':
        listbatch();
        break;
      case 'R':
        nl();
        prt(2,"Remove which? ");
        input(s,2);
        i=atoi(s);
        if ((i>0) && (i<=numbatch)) {
          delbatch(i-1);
        }
        if (numbatch==0) {
          nl();
          pl("Batch queue empty.");
          nl();
          done=1;
        }
        break;
      case 'C':
        prt(5,"Clear queue? ");
        if (yn()) {
          numbatch=0;
          numbatchdl=0;
          batchtime=0.0;
          done=1;
          pl("Queue cleared.");
        }
        break;
      case 'D':
        nl();
        if (!ratio_ok()) {
          nl();
          pl("Sorry, your ratio is too low.");
          nl();
          break;
        }

        dsz=0;
        if (syscfg.dszbatchdl[0]) {
          nl();
          pl("Please select protocol:");
          nl();
          prt(2,"Y)modem, Z)modem, Q)uit? ");
          ch=onek("QYZ");
          if (ch=='Q')
            break;
          else if (ch=='Z')
            dsz=1;
        }
        nl();
        prt(5,"Hang up after transfer? ");
        had=yn();
        nl();
        sprintf(s,"Transmitting:  Files - %d  Time - %s",numbatch,ctim(batchtime));
        pl(s);
        nl();

        if (dsz)
          dszbatchdl(had);
        else
          ymbatchdl(had);

        if (had)
          hangup=1;
        done=1;
        break;
    }
  } while ((!done) && (!hangup));
}


